#INCLUDE "rwmake.ch"

/*


ͻ
Programa   PROFER   Autor  JOSE LEITE/F. LENZI  Data   15/08/2007 
͹
Desc.     Cadastro de programacao de ferias necessario para controle  
          de multiplas programacoes de ferias em paralelo             
          Este cadastro funciona essencialmente quando nao se deseja  
          fazer alteracoes na tabela de cabecalho.                    
          Quando se deseja fazer importacao de dados de outro sistema.
͹
Uso        Folha de pagamento                                         
ͼ


*/
User Function PROFER(_cOpcao)     
	//Ŀ
	// Declaracao de Variaveis 
	//
	  
	Local 	_aCpoEnchoice 	:= {}      
    Local 	_aHeaderSave    := {}
    Local   _aColsSave	    := {}
	Local 	_cTitulo		:= ""
	Local 	_cAliasEnchoice	:= ""
	Local 	_cAliasGetD		:= ""
	Local 	_cLinOk			:= ""
	Local 	_cTudOk			:= ""
	Local 	_cFieldOk		:= ""
	Local 	_nUsado 		:= 0
	Local 	_ni	  			:= 0 
	Local 	_nPosIt 		:= 0
	Local 	_nOpcE			:= 0 
	Local 	_nOpcG			:= 0
	Private _bHabilita 		:= .T.  // Variavel utilizada no X3_WHEN dos campos do SZ3
	//Ŀ
	// Opcoes de acesso para a Modelo 3                             
	//
	Do Case
		Case _cOpcao ="I"; _nOpcE:=3 ; _nOpcG:=3; _bHabilita := .T. 
		Case _cOpcao ="A"; _nOpcE:=3 ; _nOpcG:=3; _bHabilita := .F. 
		Case _cOpcao ="V"; _nOpcE:=2 ; _nOpcG:=2; _bHabilita := .F. 
		Case _cOpcao ="E"; _nOpcE:=2 ; _nOpcG:=2; _bHabilita := .F. 
	EndCase
	//Ŀ
	//Se o aHeader e o aCols estiverem declarados (se esta       
	//rotina estiver sendo chamada de outra qq, como o MATA103), 
	//guardo os valores dos mesmos para depois restaurar.        
	//
	If (Type("aHeader")!="U")
		_aHeaderSave := aClone(aHeader)
		_aColsSave   := aClone(aCols)    
		aHeader 	 := {}
		aCols 		 := {}
	EndIf
	 
	//Ŀ
	// Cria variaveis M->????? da Enchoice                          
	//
	dbSelectArea("SRA")
	RegToMemory(("SRA"),(_cOpcao = "I"))
	
	//Ŀ
	// Cria cabecario da gride                             
	//
	
	dbSelectArea("SX3")
	dbSeek("SZO")
	aHeader:={}
	While !Eof().And.(X3_ARQUIVO = "SZO")                           		//
		If (x3_campo = "ZO_MAT")											//Suprimir o codigo da gride  
	    	dbSkip()                                                    	//Caso queira suprimir algum 
	    	Loop                                                            //campo da grid acrescenta-lo
	    EndIf                                                              	//junto ao campo zo_mat
																			//
	    If X3USO(x3_usado).And.cNivel>=x3_nivel                            	//Criacao da gride SZO
	    _nUsado:=_nUsado+1                                                 	//O primeiro campo da chave do 
	    		Aadd(aHeader,{ TRIM(x3_titulo), x3_campo, x3_picture,;    	//indice deve ser retirado da grid
				x3_tamanho, x3_decimal,"AllwaysTrue()",;                   	//obrigatoriamente. Neste caso
	    		x3_usado, x3_tipo, x3_arquivo, x3_context } )              	// "ZO_MAT"
		Endif                                                              	//
	    dbSkip()                                                          	//
	End                                                               		//
	
	aCols:={}

	//Ŀ
	//Adicionando Itens na gride
	//
	dbSelectArea("SZO")
	dbSetOrder(2)
	dbSeek(xFilial("SZO") + M->RA_MAT )
	While (!Eof()) .And. (ZO_MAT = M->RA_MAT)
		aADD(aCols,Array(_nUsado+1))
		For _ni:=1 to _nUsado
					If aHeader[_ni,10] = "V"
					aCols[Len(aCols),_ni]:=CriaVar(aHeader[_ni,2])
					Else
					aCols[Len(aCols),_ni]:=FieldGet(FieldPos(aHeader[_ni,2]))
					EndIf
			Next 
					aCols[Len(aCols),_nUsado+1]:=.F.
   			dbSkip()
	End     
	/*BEGINDOC
	//Ŀ
	//Quando o numero de itens for igual a zero, isso ocorre na inclusao de dados novos.
	//
	ENDDOC*/
	If (Len(aCols) = 0)   
		aCols:= {Array(_nUsado+1)}
		aCols[1,_nUsado+1]:=.F.
				For _ni:=1 to _nUsado
				aCols[1,_ni]:=CriaVar(aHeader[_ni,2])
				Next
				_nPosIt	:= aScan(aHeader, { |x| x[2] = "ZO_SEQ"})
				aCols[1,_nPosIt] := "01"
	EndIf
	//Ŀ
	// Executa a Modelo 3                                           
	//
	_cTitulo:="Programao de Frias"
	_cAliasEnchoice:="SRA"
	_cAliasGetD:="SZO"
	_cLinOk:="AllwaysTrue()"
	_cTudOk:="AllwaysTrue()"
	_cFieldOk:="AllwaysTrue()"
	_aCpoEnchoice := {}
	//Ŀ
	// Cabecario do SRA                                             
	//
	dbSelectArea("SX3")
   	dbSeek("SRA")
	While !Eof() .And. X3_ARQUIVO == 'SRA'
	// Retira campos seguintes do cabecalho da grid
	  	If (x3_campo = "RA_FILIAL") .Or. (x3_campo = "RA_CC") 	.Or.;
 		   (x3_campo = "RA_CIC") 	.Or. (x3_campo = "RA_PIS") 	.Or. (x3_campo = "RA_RG") .Or. (x3_campo = "RA_NUMCP").Or.;
 		   (x3_campo = "RA_SERCP")	.Or.(x3_campo = "RA_UFCP")	.Or.(x3_campo = "RA_HABILIT").Or.(x3_campo = "RA_RESERVI").Or.;
		   (x3_campo = "RA_TITULOE").Or.(x3_campo = "RA_ZONASEC").Or.(x3_campo = "RA_ENDEREC").Or.(x3_campo = "RA_COMPLEM").Or.;
		   (x3_campo = "RA_BAIRRO")	.Or.(x3_campo = "RA_MUNICIP").Or.(x3_campo = "RA_ESTADO").Or.(x3_campo = "RA_CEP").Or.;
		   (x3_campo = "RA_TELEFON").Or.(x3_campo = "RA_PAI").Or.(x3_campo = "RA_MAE").Or.(x3_campo = "RA_SEXO").Or.;
		   (x3_campo = "RA_ESTCIVI").Or.(x3_campo = "RA_MATRI").Or.(x3_campo = "RA_NATURAL").Or.(x3_campo = "RA_NACIONA").Or.;
		   (x3_campo = "RA_ANOCHEG").Or.(x3_campo = "RA_DEPIR").Or.(x3_campo = "RA_DEPSF").Or.(x3_campo = "RA_NASC").Or.;
		   (x3_campo = "RA_ADMISSA").Or.(x3_campo = "RA_OPCAO").Or.(x3_campo = "RA_DEMISSA").Or.(x3_campo = "RA_VCTOEXP").Or.;
		   (x3_campo = "RA_EXAMEDI").Or.(x3_campo = "RA_BCDEPSA").Or.(x3_campo = "RA_CTDEPSA").Or.(x3_campo = "RA_QTDV").Or.;
		   (x3_campo = "RA_CTDPFGT").Or.(x3_campo = "RA_BCDPFGT").Or.(x3_campo = "RA_SITFOLH").Or.(x3_campo = "RA_HRSMES").Or.;
		   (x3_campo = "RA_HRSEMAN").Or.(x3_campo = "RA_CHAPA").Or.(x3_campo = "RA_TNOTRAB").Or.(x3_campo = "RA_CODFUNC").Or.;
		   (x3_campo = "RA_CBO")	.Or.(x3_campo = "RA_PGCTSIN").Or.(x3_campo = "RA_SINDICA").Or.(x3_campo = "RA_ASMEDIC").Or.;
		   (x3_campo = "RA_DPASSME").Or.(x3_campo = "RA_ADTPOSE").Or.(x3_campo = "RA_CESTAB").Or.(x3_campo = "RA_VALEREF").Or.;
		   (x3_campo = "RA_SEGUROV").Or.(x3_campo = "RA_PENSALI").Or.(x3_campo = "RA_FAIXA").Or.(x3_campo = "RA_PERCADT").Or.;
		   (x3_campo = "RA_CATFUNC").Or.(x3_campo = "RA_TIPOPGT").Or.(x3_campo = "RA_SALARIO").Or.(x3_campo = "RA_ANTEAUM").Or.;
		   (x3_campo = "RA_BASEINS").Or.(x3_campo = "RA_INSSOUT").Or.(x3_campo = "RA_PERICUL").Or.(x3_campo = "RA_INSMIN").Or.;
		   (x3_campo = "RA_INSMED")	.Or.(x3_campo = "RA_INSMAX").Or.(x3_campo = "RA_TIPOADM").Or.(x3_campo = "RA_AFASFGT").Or.;
		   (x3_campo = "RA_VIEMRAI").Or.(x3_campo = "RA_GRINRAI").Or.(x3_campo = "RA_RESCRAI").Or.(x3_campo = "RA_MESTRAB").Or.;
		   (x3_campo = "RA_MESESAN").Or.(x3_campo = "RA_ALTEND").Or.(x3_campo = "RA_ALTCP").Or.(x3_campo = "RA_ALTPIS").Or.;
		   (x3_campo = "RA_ALTADM")	.Or.(x3_campo = "RA_ALTOPC").Or.(x3_campo = "RA_ALTNOME").Or.(x3_campo = "RA_CODRET").Or.;
		   (x3_campo = "RA_CRACHA")	.Or.(x3_campo = "RA_REGRA").Or.(x3_campo = "RA_BITMAP").Or.(x3_campo = "RA_SEQTURN").Or.;
		   (x3_campo = "RA_SENHA")	.Or.(x3_campo = "RA_REGISTR").Or.(x3_campo = "RA_FICHA").Or.(x3_campo = "RA_TPCONTR").Or.;
		   (x3_campo = "RA_NIVEL")	.Or.(x3_campo = "RA_TECNICO").Or.(x3_campo = "RA_APELIDO").Or.(x3_campo = "RA_TPRCBT").Or.;
		   (x3_campo = "RA_TCFMSG")	.Or.(x3_campo = "RA_INSSSC").Or.(x3_campo = "RA_CLASSEC").Or.(x3_campo = "RA_OCORREN").Or.;
		   (x3_campo = "RA_PERCSAT").Or.(x3_campo = "RA_DISTSN").Or.(x3_campo = "RA_DEFIFIS").Or.(x3_campo = "RA_BHFOL").Or.;
		   (x3_campo = "RA_ACUMBH")	.Or.(x3_campo = "RA_RACACOR").Or.(x3_campo = "RA_TABELA").Or.(x3_campo = "RA_TABFAIX").Or.;
		   (x3_campo = "RA_TABNIVE").Or.(x3_campo = "RA_RECMAIL").Or.(x3_campo = "RA_RECPFNC").Or.(x3_campo = "RA_EMAIL").Or.;
		   (x3_campo = "RA_RGORG")	.Or.(x3_campo = "RA_PERFGTS").Or.(x3_campo = "RA_DTVTEST").Or.(x3_campo = "RA_COMISSA").Or.;
		   (x3_campo = "RA_VCTEXP2").Or.(x3_campo = "RA_CATEG").Or.(x3_campo = "RA_TPMAIL").Or.(x3_campo = "RA_CODIGO").Or.;
		   (x3_campo = "RA_CARGO")	.Or.(x3_campo = "RA_BRPDH").Or.(x3_campo = "RA_OKTRANS").Or.(x3_campo = "RA_CODTIT").Or.;
		   (x3_campo = "RA_MSBLQL")	.Or.(x3_campo = "RA_DATEXPE").Or.(x3_campo = "RA_SERIEMI").Or.(x3_campo = "RA_UFCMIL").Or.;
		   (x3_campo = "RA_UFELEIT").Or.(x3_campo = "RA_CGADM").Or.(x3_campo = "RA_FUNADM").Or.(x3_campo = "RA_CATHAB").Or.;
		   (x3_campo = "RA_GERENTE").Or.(x3_campo = "RA_PCCSADE").Or.(x3_campo = "RA_COMPL1").Or.(x3_campo = "RA_COMPL2").Or.;
		   (x3_campo = "RA_COMPL3")	.Or.(x3_campo = "RA_TPDEFFI").Or.(x3_campo = "RA_ALTURA") .Or. (x3_campo = "RA_ITEM") .Or. (x3_campo = "RA_CLVL")
	    dbSkip()                                                    	//
	    Loop                                                            //
		Endif

		If X3USO(x3_usado).And.cNivel>=x3_nivel
	    	  Aadd(_aCpoEnchoice,x3_campo)
		Endif
	    dbSkip()
	End    
	
	_lRet:=Modelo3(_cTitulo,_cAliasEnchoice,_cAliasGetD,_aCpoEnchoice,_cLinOk,_cTudOk,_nOpcE,_nOpcG,_cFieldOk)
		
	
	//Ŀ
	// Executar processamento                                       
	//
	
	
	If _lRet
		If _cOpcao = "I" .Or. _cOpcao = "A"
			GravaDados(_cOpcao)
		Elseif _cOpcao = "E"
			ExcluiDados()
		EndIf
	Else
		RollBackSX8()
	Endif
	

	
	//Ŀ
	//Se existe o aHeader backupeado
	//
	If Len(_aHeaderSave) > 0    
		aHeader := aClone(_aHeaderSave)
		aCols   := aClone(_aColsSave)    
    EndIf
Return


                                               
/*


ͻ
Funcao    GravaDadosAutor  FLAVIO SILVA         Data   13/05/2002 
͹
Desc.      Funcao que gravara os dados da Modelo 3...                 
           _cOpcao = Opcao de Operacao ("INCLUIR" ou "ALTERAR")       
͹
Uso        AP5 - CEPROMAT                                             
ͼ


*/

Static Function GravaDados(_cOpcao)
	Local _nPosDel 	:= Len(aHeader) + 1
	Local _nPosIt  	:= aScan(aHeader, { |x| x[2] = "ZO_SEQ"})
	Local _cCampo	:= ""
	Begin Transaction
		//Ŀ
		//Gravo o Cabecalho     Caso precise gravar dados na tabela de cabecalho Habilite
		//
		
		//dbSelectArea("SX3") // Posiciono o SX3 pra gravar o cabecalho
		//dbSeek("SRA")
		
//		If RecLock("SRA", (_cOpcao = "I"))
			
		  /*	While !SX3->(Eof()) .And. (SX3->X3_ARQUIVO = "SRA")
					_cCampo := SX3->X3_CAMPO
						If _cCampo = "RA_MAT"
						&_cCampo := xFilial("SRA") 
						Else
							If X3USO(SX3->X3_USADO) .And. (cNivel>=SX3->X3_NIVEL)
			    				&_cCampo := M->&_cCampo    
				    		Endif
						EndIf
		   	SX3->(dbSkip())
			End 
			MsUnlock()                     */
			//Ŀ
			//Gravo os itens...
			//
           	dbSelectArea("SZO")                                                 
			dbSetOrder(2)
			//Ŀ
			//Varrendo o aCols...
			//
           	For _ni := 1 to Len(aCols)
				//Ŀ
				//Se encontrou o item gravado no banco...
				// 
				dbSelectArea("SZO")                                                 
				dbSetOrder(2)
				If dbSeek(xFilial("SZO") + M->RA_MAT + aCols[_ni][_nPosIt])
						// Se a linha estiver deletada...
			    		If (aCols[_ni][_nPosDel])
			    			RecLock("SZO",.F.)
			    			dbDelete()
			    			MsUnLock()
					    Else
							//Ŀ
							//Altera o Item...
							//
			    			RecLock("SZO",.F.)
			    			For _nii := 1 to Len(aHeader)
				    		_cCampo  := ALLTRIM(aHeader[_nii,2])
				    		&_cCampo := aCols[_ni, _nii]
					    	Next
					    	MSUnlock()
			    		EndIf 	
				Else
						If !(aCols[_ni][_nPosDel])
							DbselectArea("SZO")
							RecLock("SZO",.T.)
				    		ZO_FILIAL:=M->RA_FILIAL
			    			ZO_MAT 	 :=M->RA_MAT     
			    			ZO_DATA  :=DDATABASE 
			    			ZO_SEQ   :=Str(Val(SZO->ZO_SEQ) + 1)
				    			For _nii := 1 to Len(aHeader)
				    				_cCampo  := ALLTRIM(aHeader[_nii,2])
				    				&_cCampo := aCols[_ni, _nii]
						    	Next
					    MSUnlock()
						EndIf
				EndIf
			Next	   
			
			/*BEGINDOC
			//Ŀ
			//Organiza o sequencial no banco de dados em caso de 
			//exclusao de linha da Grid.                         
			//
			ENDDOC*/
   			contseq:= 1
			dbSelectArea("SZO")                                                 
			dbSetOrder(2)
			dbSeek(xFilial("SZO") + M->RA_MAT)
			While (!Eof().And. (ZO_MAT = M->RA_MAT))			
  				If ZO_MAT = M->RA_MAT
   					RecLock("SZO",.F.)
					Replace ZO_SEQ With strzero(contseq,2)
   					MsUnLock()
   			    EndIf
    		SZO->(dbskip())
			contseq := contseq + 1
   			End
			ConfirmSX8()
	End Transaction
Return           
/*


ͻ
Funcao    ExcluiDadosAutor  FLAVIO SILVA         Data   13/05/2002 
͹
Desc.      Funcao que excluira os dados da Modelo 3...                 
͹
Uso        AP5 - CEPROMAT                                              
ͼ


*/
Static Function ExcluiDados()
	Begin Transaction
	   		dbSelectArea("SZO")
			dbSeek(xFilial("SZO") + M->RA_MAT)
		While !EOF() .And.	ZO_MAT = M->RA_MAT 
				RecLock("SZO",.F.)
					dbDelete()
				MSUnlock()
				dbSkip()	
		End 
	End Transaction
Return